#include <iostream>
#include "svg.h"
#include <string>
#include "histogram_internal.h"
using namespace std;

void svg_begin(double width, double height)
{
    cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    cout << "<svg ";
    cout << "width='" << width << "' ";
    cout << "height='" << height << "' ";
    cout << "viewBox='0 0 " << width << " " << height << "' ";
    cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void svg_end()
{
    cout << "</svg>\n";
}

void svg_text(double left, double baseline, string text)
{

    cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>";
}


void svg_rect(double x, double y, double width, double height, string stroke = "black", string fill = "black")
{
    cout << "<rect x='" << x << "' y='" << y << "' width='" << width
              << "' height='" << height << "' stroke='" << stroke << "' fill='" << fill << " '/>";
}
void show_histogram_svg(const vector<size_t> &bins)
{

    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;

    svg_begin(400, 300);
    double top = 0;

    size_t max_count = 0;
    for (auto bin : bins)
    {
        if (bin > max_count)
            max_count = bin;
    }
	cerr << "BLOCK_WIDTH=";
    double BLOCK_WIDTH;
    cin >> BLOCK_WIDTH;
    bool prov=1;

    if((BLOCK_WIDTH<3) || (BLOCK_WIDTH>30)){
        BLOCK_WIDTH = -1;
        prov=0;
        while(prov==0){
            cout<< "Error range from 3 to 30 pi" << endl;
            cout<< "BLOCK_WIDTH=";
            cin >> BLOCK_WIDTH;
        if((BLOCK_WIDTH>3) && (BLOCK_WIDTH<30) ){
            prov=1;
            }
    }
  }

if ((max_count * BLOCK_WIDTH) > (IMAGE_WIDTH - TEXT_WIDTH)){
    for (size_t bin : bins)
    {
        const double bin_width = (IMAGE_WIDTH - TEXT_WIDTH) * (static_cast<double>(bin)/max_count);
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, std::to_string(bin));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT, "blue", "green");
        top += BIN_HEIGHT;
    }
  }
else{
        for (size_t bin : bins)
    {
        const double bin_width = BLOCK_WIDTH * bin;
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, std::to_string(bin));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT, "blue", "green");
        top += BIN_HEIGHT;
    }
}

    svg_end();
}


